gtk-sharp 0.0.0.0 neutral Gtk# is thread aware, but not thread safe; See the Gtk# Thread Programming for details.$ GtkWidget introduces style properties - these are basically object properties that are stored in the style object associated to the .

Style properties are set in resource files. This mechanism is used for configuring such things as the location of the scrollbar arrows through the theme, giving theme authors more control over the look of applications without the need to write a theme engine in C.

Use , or to obtain the value of a style property.

Gtk.Object Atk.Implementor GLib.IWrapper GLib.IWrapper System.IDisposable
- Method
  System.Void Makes all newly-created as composite children until the corresponding call.

  A composite child is a child that's an implementation detail of the container it's inside and should not be visible to people using the container. Composite children aren't treated differently by GTK# (but see vs. ), but e.g. GUI builders might want to treat them in a different way.

- Method
  System.Void `` Pushes onto a global stack of colormaps. Colormap that is pushed by .

  Pushes onto a global stack of colormaps; the topmost colormap on the stack will be used to create all . Remove with . There's little reason to use this method.

- Method
  System.Void Removes a colormap pushed with .

  Removes a colormap pushed with .

- Method
  System.Void Cancels the effect of a previous call to .

  Cancels the effect of a previous call to .

- Method
  Atk.Object Gets a reference to an object's implementation. An .

  Gets a reference to an object's implementation.

- Method
  System.Void Shows a .

  If the is an unmapped toplevel , a that has not yet been shown, enter the main loop and wait for the window to actually be mapped. Be careful, because the main loop is running, anything can happen during this method.

- Method
  System.Void Causes to become the default .

  The default is activated when the user presses Enter in a window. Default must be activatable, that is, should affect them. The must have the flag set; typically you have to set this flag yourself by calling .

- Method
  System.Void `` Moves a from one to another, handling reference count issues to avoid destroying the . A to move the into.

  Moves a from one to another, handling reference count issues to avoid destroying the .

- Method
  System.Boolean `` Move focus to particular . Direction of focus movement. if focus ended up inside .

  This method is used by custom implementations; if you're writing an app, you'd use to move the focus to a particular , and to change the focus tab order. So you may want to investigate those methods instead.

  is called by containers as the user moves around the window using keyboard shortcuts. indicates what kind of motion is taking place (up, down, left, right, tab forward, tab backward). invokes the event on ; override the default handler for this event in order to implement appropriate focus behavior.

  The "focus" default handler for a should return if moving in direction left the focus on a focusable location inside that , and if moving in direction moved the focus outside the . If returning , normally call to place the focus accordingly; if returning , they don't modify the current focus location.

- Method
  System.Void Should be called by implementations of the remove method on , to dissociate a child from the container.

  This method is only for use in widget implementations.

- Method
  System.Void Creates the GDK (windowing system) resources associated with a .

  For example, ->window will be created when a is realized. Normally realization happens implicitly; if you show a and all its parent containers, then it will be realized and mapped automatically. Realizing a requires all the widget's parent widgets to be realized; calling realizes the widget's parents in addition to itself. If a is not yet inside a toplevel window when you realize it, bad things will happen.

  This method is primarily used in widget implementations, and isn't very useful otherwise. Many times when you think you might need it, a better approach is to connect to a event that will be called after the is realized automatically, such as . Or simply to the realize event.

- Method
  System.Void `` `` `` `` Invalidates the rectangular area of a . y coordinate of upper-left corner of rectangle to redraw. x coordinate of upper-left corner of rectangle to redraw. Width of region to draw. Height of region to draw.

  Invalidates the rectangular area of defined by , , and by calling on the 's window and all its child windows. Once the main loop becomes idle (after the current batch of events has been processed, roughly), the window will receive events for the union of all regions that have been invalidated.

  Normally you would only use this method in widget implementations. You might also use it, or directly, to schedule a redraw of a or some portion thereof. Frequently you can just call or instead of this method. Those methods will invalidate only a single window, instead of the and all its children.

  The advantage of adding to the invalidated region compared to simply drawing immediately is efficiency; using an invalid region ensures that you only have to redraw one time.

- Method
  System.Void `` `` Sets the foreground for a in a particular . The state for which to set the background color. The color to assign (does not need to be allocated), or to undo the effect of previous calls to of .

  All other style values are left untouched. See also .

- Method
  Gdk.Pixbuf `` `` `` A convenience method that uses the theme engine and RC file settings for to look up and render it to a . A stock ID. A stock size. Render detail to pass to theme engine. A new , or if the wasn't known.

  The should be a stock icon ID such as or . should be a size such as . should be a string that identifies the or code doing the rendering, so that theme engines can special-case rendering for that or code.

  The pixels in the returned are shared with the rest of the application and should not be modified. The should be freed after use with .

- Method
  System.Void `` `` Gets the values of a multiple style properties of . The name of the first property to get. A va_list of pairs of property names and locations to return the property values, starting with the location for .

  Gets the values of a multiple style properties of . Used primarily by language bindings.

- Method
  System.Void Recursively shows a , and any child (if the widget is a container).

  Recursively shows a , and any child (if the widget is a container).

- Method
  System.Void `` `` Sets the text for a in a particular state. The state for which to set the text color. The color to assign (does not need to be allocated), or to undo the effect of previous calls to of .

  All other style values are left untouched. The text color is the foreground color used along with the base color (see ) for such as and . See also .

- Method
  Pango.Context Creates a new with the appropriate colormap, font description, and base direction for drawing text for . The new .

  See also .

- Method
  System.Boolean Utility method; intended to be connected to the event on a . Returns .

  The method calls on its argument, then returns . If connected to , the result is that clicking the close button for a window (on the window frame, top right corner usually) will hide but not destroy the window. By default, GTK+ destroys windows when is received.

- Method
  System.Void Causes a to have the keyboard focus for the it's inside.

  The must be a focusable , such as a ; something like won't work (More precisely, it must have the flag set).

- Method
  System.Void Equivalent to calling for the entire area of a .

  Equivalent to calling for the entire area of a .

- Method
  System.Void `` `` Given an accelerator group, , and an accelerator path, , sets up an accelerator in so whenever the key binding that is defined for is pressed, will be activated. Path used to look up the the accelerator. A .

  This removes any accelerators (for any accelerator group) installed by previous calls to . Associating accelerators with paths allows them to be modified by the user and the modifications to be saved for future use.

  This is a low level method that would most likely be used by a menu creation system like . If you use , setting up accelerator paths will be done automatically.

- Method
  System.Void Flags a to be displayed.

  Any that isn't shown will not appear on the screen. If you want to show all the in a container, it's easier to call on the container, instead of individually showing the .

  Remember that you have to show the containers containing a , in addition to the itself, before it will appear onscreen. And that when a toplevel container is shown, it is immediately realized and mapped; other shown are realized and mapped when their toplevel container is realized and mapped.

- Method
  System.Boolean `` `` For that support scrolling, sets the scroll adjustments. An adjustment for horizontal scrolling, or . An adjustment for vertical scrolling, or . Returns if the supports scrolling.

  For that don't support scrolling, does nothing and returns . that don't support scrolling can be scrolled by placing them in a , which does support scrolling.

- Method
  Pango.Layout `` Creates a new with the appropriate colormap, font description, and base direction for drawing text for . text to set on the layout (can be ). The new .

  If you keep a created in this way around, in order notify the layout of changes to the base direction or font of this , you must call in response to the and events for the .

- Method
  System.Void Reset the styles of and all descendents, so when they are looked up again, they get the correct values for the currently loaded RC file settings.

  This method is not useful for applications.

- Method
  System.Boolean For that can be "activated" (buttons, menu items, etc.) this method activates them. Returns if the was activatable.

  Activation is what happens when you press Enter on a widget during key navigation; clicking a button, selecting a menu item, etc. If the isn't activatable, the method returns .

- Method
  System.Void `` `` Sets the background color for a in a particular state. The state for which to set the background color. The color to assign (does not need to be allocated), or to undo the effect of previous calls of .

  All other style values are left untouched. See also .

- Method
  System.Boolean `` Rarely-used method. This method is used to emit the events on a . A . Return from the event emission ( if the event was handled)

  If you want to synthesize an event though, don't use this method; instead, use to invalidate a region of the window.

- Method
  System.Void Reverses the effects of , causing the to be hidden (invisible to the user).

  Reverses the effects of , causing the to be hidden (invisible to the user).

- Method
  System.Void `` `` Sets the base color for a in a particular state. The state for which to set the base color. The color to assign (does not need to be allocated), or to undo the effect of previous calls to of .

  All other style values are left untouched. The base color is the background color used along with the text color (see ) for such as and . See also .

- Method
  System.Void Recursively resets the shape on and its descendants.

  Recursively resets the shape on this and its descendants.

- Method
  System.Void `` Modifies style values on the . The holding the style modifications.

  Modifications made using this technique take precedence over style values set via an RC file, however, they will be overriden if a is explicitely set on the using . The structure is designed so each field can either be set or unset, so it is possible, using this method, to modify some style values and leave the others unchanged.

  Note that modifications made with this method are not cumulative with previous calls to or with such methods as . If you wish to retain previous values, you must first call , make your modifications to the returned , then call with that . On the other hand, if you first call , subsequent calls to such methods will have a cumulative effect with the initial modifications.

- Method
  System.Void `` `` Sets the minimum size of a ; that is, the 's size request will be by . Width should request, or -1 to unset. Weight should request, or -1 to unset.

  You can use this method to force a to be either larger or smaller than it normally would be. In most cases, is a better choice for toplevel windows than this method; setting the default size will still allow users to shrink the window. Setting the size request will force them to leave the window at least as large as the size request. When dealing with window sizes, can be a useful method as well.

  Note the inherent danger of setting any fixed size - themes, translations into other languages, different fonts, and user action can all change the appropriate size for a given . So, it's basically impossible to hardcode a size that will always be correct. The size request of a is the smallest size a can accept while still methoding well and drawing itself correctly. However in some strange cases a may be allocated less than its requested size, and in many cases a may be allocated more space than it requested.

- Method
  System.Boolean `` Activates the targets associated with the mnemonic. A boolean; set to true if the list of targets should cycle once the end of the list is reached. if the activation is done.
- Method
  System.Void `` `` Gets the size request that was explicitly set for the using . Return location for width, or . Return location for height, or .

  A value of -1 stored in or indicates that that dimension has not been set explicitly and the natural requisition of the will be used intead. See . To get the size a will actually use, call instead of this method.

- Method
  System.Boolean `` `` `` Removes an accelerator from , previously installed with . Accel group for this . GDK keyval of the accelerator. Modifier key combination of the accelerator. Returns whether an accelerator was installed and could be removed.

  Removes an accelerator from , previously installed with .

- Method
  System.Void Causes a to be unmapped if it's currently mapped.

  This method is only for use in widget implementations.

- Method
  System.Void Causes a to be mapped if it isn't already.

  This method is only for use in widget implementations.

- Method
  Gdk.Region `` Computes the intersection of a 's area and , returning the intersection. A , in the same coordinate system as ->allocation. That is, relative to ->window for ; relative to the parent window of ->window for widgets with their own window. A newly allocated region holding the intersection of and . The coordinates of the return value are relative to ->window for , and relative to the parent window of ->window for widgets with their own window.

  The result may be empty, use to check.

- Method
  System.Void Flags a to have its size renegotiated; should be called when a for some reason has a new .

  This method is only for use in widget implementations. One example, when you change the text in a , it queues a resize to ensure there's enough space for the new text.

- Method
  System.Void `` Sets the font to use for a . The font description to use, or to undo the effect of previous calls to .

  All other style values are left untouched. See also .

- Method
  System.Int32 `` Very rarely-used method. This method is used to emit an events on a . A . Return from the event emission ( if the event was handled).

  This method is not normally used directly. The only time it is used is when propagating an to a child , and that is normally done using . If you want to force an area of a window to be redrawn, use or . To cause the redraw to be done immediately, follow that call with a call to .

- Method
  System.Void Causes a to be unrealized (frees all GDK resources associated with the widget).

  This method is only useful in widget implementations.

- Method
  System.Void Ensures that has a style (->style).

  Not a very useful method; most of the time, if you want the style, the is realized, and realized are guaranteed to have a style already.

- Method
  System.Boolean `` Determines whether is somewhere inside , possibly with intermediate containers. Another . Returns if ancestor contains as a child, grandchild, great grandchild, etc.

  Determines whether is somewhere inside , possibly with intermediate containers.

- Method
  System.Void `` Adds the events in the bitfield to the event mask for .

  See for details.

- Method
  System.Void Recursively hides a and any child .

  Recursively hides a and any child .

- Method
  System.Void Reverts the effect of a previous call to .

  Reverts the effect of a previous call to . This causes all queued events on to be emitted.

- Method
  System.Void `` `` `` Sets a shape for this 's GDK window. This allows for transparent windows etc., see for more information. Shape to be added, or to remove an existing shape. X position of shape mask with respect to the window. Y position of shape mask with respect to the window.

  Sets a shape for this 's GDK window. This allows for transparent windows etc., see for more information.

- Method
  System.Void `` Emits a event for the child property on . The name of a child property installed on the class of widget's parent.

  Emits a event for the child property on .

- Method
  System.Void Destroys a .

  Equivalent to , except that you don't have to cast the to . When a is destroyed, it will break any references it holds to other objects. If the is inside a container, the will be removed from the container. If the is a toplevel (derived from ), it will be removed from the list of toplevels, and the reference GTK+ holds to it will be removed.

  Removing a from its container or the list of toplevels results in the being finalized, unless you've added additional references to the with .In most cases, only toplevel widgets (windows) require explicit destruction, because when you destroy a toplevel its children will be destroyed as well.

- Method
  System.Void Stops emission of events on .

  The events are queued until is called on .

- Method
  System.Void `` This method is only used by subclasses, to assign a size and position to their child . A position and size to be allocated to .

  This fuction is only used by subclasses, to assign a size and position to their child .

- Method
  System.Void Disposes the resources associated with the object.
- Constructor
  Internal constructor
  Pointer to the C object.
  An instance of Widget, wrapping the C object.

  This is an internal constructor, and should not be used by user code.

- Property
  Gdk.Visual Obtains the visual of the default colormap. Returns a visual of the default colormap.

  Not really useful; used to be useful before existed.

- Property
  Gtk.Style Obtains the default style used by all initially. Returns the default style. This object is owned by GTK+ and should not be modified or freed.

  Returns the default style used by all initially.

- Property
  Gdk.Colormap Sets or obtains the default colormap to use when creating . A colormap (see ). A .

  is a better method to use if you only want to affect a few widgets, rather than all widgets.

- Property
  Gtk.TextDirection Sets or obtains the default reading direction for . A . A .

  Where the direction has not been explicitly set by .

- Property
  Atk.Object Obtains the default reading direction for . A . Obtains the default reading direction for .
- Property
  Gtk.TextDirection Sets or obtains the reading direction on a particular . A . The reading direction for the .

  This direction controls the primary direction for containing text, and also the direction in which the children of a container are packed. The ability to set the direction is present in order so that correct localization into languages with right-to-left reading directions can be done. Generally, applications will let the default reading direction present, except for containers where the containers are arranged in an order that is explicitely visual rather than logical (such as buttons for text justification). If the direction is set none, then the value set by will be used.

- Property
  Gdk.Colormap Sets or obtains the colormap that will be used to render . A colormap (see ). A .

  Widget must not have been previously realized.

- Property
  System.Boolean Sets or obtains whether should be mapped along with its when its parent is mapped and has been shown with . If , should be mapped along with its parent. Returns if the is mapped with the parent.

  The child visibility can be set for before it is added to a container with , to avoid mapping children unnecessary before immediately unmapping them. However it will be reset to its default state of when the is removed from a container.

  Note that changing the child visibility of a does not queue a resize on the . Most of the time, the size of a is computed from all visible children, whether or not they are mapped. If this is not the case, the container can queue a resize itself. This property is only useful for container implementations and never should be called by an application.

- Property
  System.String Sets or obtains a composite name. The name to set. The composite name of , or if is not a composite child. The string should not be freed when it is no longer needed.

  The must be a composite child of its parent; see .

- Property
  Gtk.Widget Obtains the topmost in the container hierarchy is a part of. The topmost ancestor of , or itself if there's no ancestor.

  Note the difference in behavior against , would return if wasn't inside a toplevel window, and if the window was inside a GtkWindow-derived which was in turn inside the toplevel . While the second case may seem unlikely, it actually happens when a is embedded inside a within the same application. To reliably find the toplevel , use and check if the flag is set on the result.

- Property
  System.Boolean Sets whether a size allocation changes, the entire is queued for drawing. the entire will be redrawn when it is allocated to a new size. only the new portion of the will be redrawn. Returns because it is on by Default, but returns if you turn it off.

  By default, this setting is and the entire is redrawn on every size change. If your leaves the upper left are unchanged when made bigger, turning this setting on will improve performance.

  Note that for setting this flag to turns off all allocation on resizing: the will not even redraw if its position changes; this is to allow containers that don't draw anything to avoid excess invalidations. If you set this flag on a that does draw on ->window, you are responsible for invalidating both the old and new allocation of the when the is moved and responsible for invalidating regions newly when the increases size.

- Property
  System.Boolean Use this property to turn off the double buffering. is on by Default, if you want to turn off double buffering no use call for true because it is default. Returns because double buffering is on by Default, but returns if you turn it off.

  Widgets are double buffered by default, you can use this property to turn off the buffering. "Double buffered" simply means that and are called automatically around events sent to the . diverts all drawing to a 's window to an offscreen buffer, and draws the buffer to the screen. The result is that users see the window update in one smooth step, and don't see individual graphics primitives being rendered.

  In very simple terms, double buffered don't flicker, so you would only use this property to turn off double buffering if you had special needs and really knew what you were doing.

- Property
  Gtk.Settings Obtains the settings object holding the settings (global property settings, RC file information, etc) used for this . The relevant object.

  Note that this property can only be called when the is attached to a toplevel, since the settings object is specific to a particular .

- Property
  Gdk.Window Sets or obtains 's parent window. The new parent window. The parent window of .

  Sets or obtains 's parent window.

- Property
  Pango.Context Obtains a with the appropriate colormap, font description and base direction for .

  Unlike the context returned by , this context is owned by the (it can be used until the screen for the changes or the is removed from its toplevel), and will be updated to match any changes to the 's attributes.

  If you create and keep a using this context, you must deal with changes to the context by calling on the layout in response to the and events for the .

- Property
  Gdk.Visual Obtains the visual that will be used to render . The visual for .

  Obtains the visual that will be used to render .

- Property
  Gtk.RcStyle Obtains the current modifier style for the .(As set by ) The modifier style for the . This rc style is owned by the .

  If no style has previously set, a new will be created with all values unset, and set as the modifier style for the . If you make changes to this rc style, you must call , passing in the returned rc style, to make sure that your changes take effect.

  Caution: passing the style back to will normally end up destroying it, because copies the passed-in style and sets the copy as the new modifier style, thus dropping any reference to the old modifier style. Add a reference to the modifier style if you want to keep it alive.

- Property
  System.Boolean Whether the is visible. If the widget is set to be visible. if the widget is meant to be visible.
- Property
  System.Int32 Override for the width request for the . The width to be set for the . The width of the . Or -1 if natural request should be used.
- Property
  System.Boolean Sets the sensitivity of the . A widget is sensitive if the user can interact with it, otherwise, it is grayed. A System.Boolean value. Set to to enable the sensitivity, this is, whether the widget should respond to input or not. if the responds to input.

  Insensitive widgets are "grayed out" and the user can't interact with them. Insensitive widgets are known as "inactive", "disabled", or "ghosted" in some other toolkits. The sensitivity of a widget determines whether it will receive certain events (e.g. button or key presses).

  If the ancestor (parent) widget sesitivity is set to false, it does not matter what the sensitivity property have, the widget will not be sensitive. Use widget.Parent.Sensitive to check whether the ancestor widget is sensitive or not.

  When the sensitive property is set to false, the widget property will return false.

- Property
  System.Boolean Whether to make the receive the default action when it is focused. If the will receive the default action when is focused. if the will receive the default action when is focused.
- Property
  System.Boolean Whether the has the input focus. If the has the input focus. if the has the input focus.
- Property
  Gdk.ExtensionMode The mask that decides what kind of extension events the gets. A Gdk.ExtensionMode. A Gdk.ExtensionMode.
- Property
  System.Boolean when the currently is receiving the default action. If the is the default . Evaluates to if the currently is receiving the default action. When the is focused will receive the default action, and HasDefault will be even if there is a different widget set as default.
- Property
  System.Boolean Whether the is part of a composite widget. if the is part of a composite widget.
- Property
  System.Boolean Evaluates to if the is allowed to receive the default focus. value that get or set the capability of the widget to receive the default focus. that indicates if the widget can grab the default focus, using .

  When this property is set to true, the widget itself will reserve space to draw the default if possible.

  If either the widget's property or the 's property evaluates to false, the property will return false. Otherwise, the property will return its own value.

  Typically, you'd like to set the default widget using , but you must set the property to true before you call it, in order to force the focus to be grabbed into the widget.

  When certain conditions are met and the user press Enter, the default widget will be focused. Conditions: the property is set to true, the has been called and the containing the widget have the focus. This state is common when your window is shown for the first time, and no call has been made (or when by no other means, the focus has been set to any particular widget).

  [FIXME] This is a seealso instead see

  [FIXME] This is a seealso instead see

- Property
  System.Boolean Determines whether the is able to receive the focus. Set to to give focus capability to the . Evaluates to if the is able to handle focus grabs.

  If the widget property evaluates to , the property will also return . widget must be a focusable widget, such as an ; something like won't work. More precisely, it must have the property set.

  The property is just the helper that will tell you whether the widget is focusable.

  Evaluate it before you make a call to , if you are unsure about the "focusability" of the widget.

  [FIXME] This two links are seealso instead see: and
- Property
  System.Int32 Override for the height request for the . The height to be set for the . The height of the . Or -1 if natural request should be used.
- Property
  System.Boolean Whether the application will paint directly on the . If the application will paint directly on the . if the application will paint directly on the .
- Property
  Gtk.Widget The parent widget of this . The parent widget. The parent widget. Must be a Container ,
- Property
  System.String The name of the . The name to be set for the . The name of the .
- Property
  Gtk.Style The style of the . A style. A style. Which contains information about how it will look (colors etc).
- Event
  Gtk.UnmapEventHandler Fired whenever this widget (or its parent, if is true for the parent) is told to hide itself.
- Event
  Gtk.FocusedHandler Fired whenever this widget is focused. a The widget gets this signal as the user uses keyboard shortcuts or tabs through the widgets in a window.
- Event
  Gtk.ParentSetHandler Fired whenever this widget's parent widget is set.
- Event
  Gtk.KeyReleaseEventHandler Fired when a key is released within this widget.
- Event
  System.EventHandler Fired whenever this widget is hidden.
- Event
  Gtk.SelectionRequestEventHandler Fired whenever the widget receives a request for a selection. TODO: explain more about the X selection model
- Event
  Gtk.DirectionChangedHandler Fired when the text direction for this widget is changed.
- Event
  Gtk.DragLeaveHandler Fired when a drag action leaves this widget.
- Event
  Gtk.ScrollEventHandler Fired when the widget is scrolled.
- Event
  Gtk.VisibilityNotifyEventHandler Fired whenever the visibility state of the widget changes--- partially visible or fully visible, for example. It may be preferable to handle a instead.
- Event
  Gtk.WindowStateEventHandler To be added
- Event
  System.EventHandler Fired when this widget is mapped.
- Event
  Gtk.DragBeginHandler Fired on a source widget when the user begins a drag.
- Event
  Gtk.HierarchyChangedHandler Fired when the hierarchy (parent or child relationships) of this widget or its parent or children changes.
- Event
  Gtk.ConfigureEventHandler Fired when the configuration of the window has changed (it has been moved or resized).
- Event
  Gtk.KeyPressEventHandler Fired when a key is pressed within this widget.
- Event
  Gtk.MapEventHandler Fired just after the widget is mapped.
- Event
  System.EventHandler Fired when this widget grabs the keyboard focus.
- Event
  Gtk.MotionNotifyEventHandler Fired when the pointer moves within this widget.
- Event
  Gtk.StateChangedHandler Fired when the state of the widget changes. See for the possible states of a widget.
- Event
  Gtk.NoExposeEventHandler To be added
- Event
  System.EventHandler Fired when a widget is unrealized.
- Event
  Gtk.ButtonReleaseEventHandler Fired when a (mouse) button is released on this widget.
- Event
  Gtk.SelectionGetHandler Fired when this widget gets a selection from the clipboard.
- Event
  Gtk.SizeAllocatedHandler Fired when size is allocated for this widget.
- Event
  Gtk.PopupMenuHandler Fired when this widget's popup menu is activated.
- Event
  Gtk.ExposeEventHandler Fired when the widget needs to be (fully or partially) redrawn. See , .
- Event
  System.EventHandler Fired when the widget is shown.
- Event
  Gtk.SelectionNotifyEventHandler To be added
- Event
  Gtk.FocusInEventHandler Fired when the widget has just gained the focus.
- Event
  Gtk.ButtonPressEventHandler Fired when a button is pressed.
- Event
  Gtk.PropertyNotifyEventHandler To be added
- Event
  Gtk.HelpShownHandler Fired when the help text is shown.
- Event
  Gtk.ClientEventHandler Fired when a message is received from another application.
- Event
  Gtk.ProximityInEventHandler Fired when the user is using a stylus or touch screen and their pointer comes near the widget. See for context.
- Event
  Gtk.ProximityOutEventHandler Fired when the user is using a stylus or touch screen and their pointer leaves the area near the widget. See for context.
- Event
  Gtk.DestroyEventHandler Fired when this widget is destroyed.
- Event
  Gtk.SelectionReceivedHandler Fired when this widget is the destination of a received selection.
- Event
  Gtk.DragDataGetHandler Fired when the drag-and-drop process gets data from a source widget.
- Event
  Gtk.EnterNotifyEventHandler The pointer has just entered the widget. If the flag is set, Widget will gain the focus, and the widget might be drawn differently. If the handler returns False, the event might be passed to the parent of widget (if no other handler of widget has returned True).
- Event
  Gtk.DragDataReceivedHandler Fired on a destination widget when it receives dragged data.
- Event
  Gtk.DragMotionHandler Fired on a source widget when the user is moving a dragged selection.
- Event
  Gtk.SizeRequestedHandler Fired when this widget needs to notify another object of its preferred size.
- Event
  Gtk.GrabNotifyHandler To be added.
- Event
  Gtk.StyleSetHandler Fired when a is set for this widget.t
- Event
  Gtk.FocusOutEventHandler Fired when the focus leaves this widget.
- Event
  Gtk.ChildNotifiedHandler To be added
- Event
  System.EventHandler Fired when the widget is unmapped on the screen.
- Event
  Gtk.DragEndHandler Fired on a source widget when a drag operation is completed.
- Event
  Gtk.SelectionClearEventHandler Fired when the current selection is cleared.
- Event
  Gtk.MnemonicActivatedHandler Fired when someone presses a mnemonic key.
- Event
  Gtk.DragDropHandler Fired on a source widget when dragged data is dropped.
- Event
  Gtk.LeaveNotifyEventHandler Fired when the mouse leaves this widget.
- Event
  Gtk.DeleteEventHandler Fired when the user has clicked on the "close" button in the window's frame (the button that is automatically set by the window manager). If the handler returns False, the widget will be destroyed (and the window closed), but if the handler returns True, nothing will be done. This is a good way to prevent the user from closing your application's window if there should be some cleanups first (like saving the document).
- Event
  System.EventHandler Emitted when a widget is realized. The default handler creates the Gdk window associated with the widget, and its ancestors.
- Event
  Gtk.DragDataDeleteHandler Fired on a source widget when dragged data is deleted.
- Property
  Gdk.Window The root window this Widget is attached to. a
- Property
  Gdk.Display Obtains the for the toplevel window associated with this . The for the toplevel for this .

  This method can only be called after the has been added to a widget hierarchy with a at the top.

  In general, you should only create display specific resources when a has been realized, and you should free those resources when the is unrealized.

- Property
  Gdk.Screen Obtains the from the toplevel window associated with this . The for the toplevel for this .

  This method can only be called after the has been added to a widget hierarchy with a at the top.

  In general, you should only create screen specific resources when a has been realized, and you should free those resources when the is unrealized.

- Property
  System.Boolean Determines if the is the focus widget within its toplevel. if the is the focus widget.

  This does not mean that the flag is necessarily set; will only be set if the toplevel additionally has the global input focus.

- Event
  Gtk.ScreenChangedHandler To be added
- Method
  System.Boolean `` `` Computes the intersection of a 's area and . A rectangle. A rectangle to store intersection of and . if there was an intersection.

  Computes the intersection of a 's area and , storing the intersection in , and returns if there was an intersection. may be if you're only interested in whether there was an intersection.

- Method
  Gtk.Clipboard `` Returns the clipboard object for the given selection to be used with . A which identifies the clipboard to use. gives the default clipboard, another common value is , which gives the primary X selection. The appropiate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent for all time.

  must have a associated with it, so must be attached to a toplevel window.

- Method
  System.Void `` `` Obtains the location of the mouse pointer in coordinates. Return location for the X coordinate, or . Return location for the Y coordinate, or .

  Widget coordinates are a bit odd; for historical reasons, they are defined as ->window coordinates for widgets that are not , and are relative to ->allocation.x, ->allocation.y for widgets that are .

- Method
  System.Boolean `` `` `` `` `` Translate coordinates relative to 's allocation to coordinates relative to 's allocations. A . X position relative to source . Y position relative to source . Location to store X position relative to . Location to store Y position relative to . Returns if either was not realized, or there was no common ancestor. In this case, nothing is stored in and . Otherwise .

  In order to perform this operation, both widgets must be realized, and must share a common toplevel.

- Method
  System.Void `` `` `` Obtains the full path to . Location to store length of the path, or . Location to store allocated path string, or . Location to store allocated reverse path string, or .

  The path is simply the name of a and all its parents in the container hierarchy, separated by periods. The name of a comes from . Paths are used to apply styles to a in gtkrc configuration files. Widget names are the type of the by default (e.g. "") or can be set to an application-specific value with .

  By setting the name of a , you allow users or theme authors to apply styles to that specific in their gtkrc file. fills in the path in reverse order, i.e. starting with 's name instead of starting with the name of 's outermost ancestor.

- Method
  System.Void `` `` `` Same as , but always uses the name of a 's type, never uses a custom name set with . Location to store the length of the class path. or . Location to store the class path as an allocated string, or . Location to store the reverse class path as an allocated string, or .
- Event
  Gtk.WidgetEventHandler To be added
- Method
  System.Void `` `` Obtains the value of a style property of . The name of a style property. Location to return the property value.
- Property
  System.Boolean Checks whether there is a is associated with this . see langword="true" /> if there is a associated with the . All toplevel have an associated screen, and all added into a hierarchy with a toplevel window at the top.
- Property
  GLib.GType GType Property. a Returns the native value for .
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` `` `` `` Default handler for the event. a a a a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` `` `` `` Default handler for the event. a a a a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` `` `` `` `` `` Default handler for the event. a a a a a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` `` `` `` Default handler for the event. a a a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` `` `` Default handler for the event. a a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  Gtk.Widget `` Obtains the first ancestor of . Ancestor type. The ancesor , or see if not found.

  For example sending gets the first that's an ancstor of . No reference will be added to the retured ; it should not be unreferenced. See note about checking for a toplevel in the docs for . Note that unlike , considers to be an ancestor of itself.

- Constructor
  Protected Constructor.
  a
  a
  Chain to this constructor if you have manually registered a native value for your subclass.
- Property
  Gtk.StateType Sets or obtains the state of a (insensitive, prelighted, etc.). New state for . New state for .

  Usually you should set the state using wrapper fuctions such as . This property is for use in widget implementations.

- Event
  System.EventHandler Fired when the closures for this widget's accelerator change.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
xs
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` `` `` `` `` Installs an accelerator for this in that causes to be emitted if the accelerator is activated. Widget signal to emit on accelerator activation. Accel group for this , added to its toplevel. GDK keyval of the accelerator. Modifier key combination of the accelerator. Flag accelerators.

  The needs to be added to the widget's toplevel via , and the signal must be of type G_RUN_ACTION. Accelerators added through this method are not user changeable during runtime.

  Accelerators added through this method are not user changeable during runtime. If you want to support accelerators that can be changed by the user, use instead.

- Method
  System.Void `` `` `` Installs an accelerator for this in that causes to be emitted if the accelerator is activated. Widget signal to emit on accelerator activation. Accel group for this , added to its toplevel. GDK keyval of the accelerator.

  The needs to be added to the widget's toplevel via , and the signal must be of type G_RUN_ACTION. Accelerators added through this method are not user changeable during runtime.

  Accelerators added through this method are not user changeable during runtime. If you want to support accelerators that can be changed by the user, use instead.

- Property
  Gdk.EventMask Obtains or sets the event mask for the (a bitfield containing flags from ). a

  The event mask determines which events a will receive. Keep in mind that different widgets have different default event masks, and by changing the event mask you may disrupt a 's fuctionalit, so be careful.

  This property must be called while a is unrealized. Consider for widgets that are already realized, or if you want to preserve the existing event mask.

  This property can't be used with widgets; to get events on those events, place them inside a and receive events on the event box.

  These are the events that the will receive.

- Method
  System.Void `` Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Property
  Gdk.Window Obtains or sets the underlying Gdk.Window used to display the contents of the . a
- Property
  System.Int32 Obtains or sets the flags for this . a

  This property should only be used when writing custom widgets in C#.

  See for possible values.

- Method
  Gtk.Requisition Obtains the preferred size of a . a

  The container uses this information to arrange its child widgets and decide what size allocations to give them with .

  You can also call this method from an application, with some caveats. Most notably, getting a size request requieres the to be associated with a screen, because font information may be needed. Multihead-aware applications should keep this in mind.

  Also remember that the size request is not necessarily the size a will actually be allocated.

- Constructor
  Protected constructor.
  a
- Property
  System.Int32 The width of the focus line in a . a

  Subclasses of use this style property to correctly layout their children.

- Property
  Gdk.Rectangle Gets or Sets the widget's allocation. a representing the size of the widget's allocation.

  When the top-level widget has determined how much space its child would like to have, the second phase of the size negotiation, size allocation, begins. Depending on its configuration (see ), the top-level widget may be able to expand in order to satisfy the size request or it may have to ignore the size request and keep its fixed size. It then tells its child widget how much space it gets by calling . The child widget divides the space among its children and tells each child how much space it got, and so on. Under normal circumstances, a will always give its child the amount of space the child requested.

  A child's size allocation is represented by a . This struct contains not only a width and height, but also a position (i.e. X and Y coordinates), so that containers can tell their children not only how much space they have gotten, but also where they are positioned inside the space available to the container.

  Widgets are required to honor the size allocation they receive; a size request is only a request, and widgets must be able to cope with any size.

  None.
- Property
  System.Boolean Check to see if the widget is Mapped true if the widget is Mapped, false otherwise. None.
- Property
  System.Boolean Checks to see if the widget is Realized returns true if the widget is Realized None.
- Property
  System.Boolean Convenience property to check Flags for WidgetFlags.NoWindow True if the NoWindow flag is set. None.
- Property
  System.Boolean Convenience property to check Flags for WidgetFlags.Toplevel True if the Toplevel flag is set. None
- Property
  System.Boolean Convenience property to check Flags for WidgetFlags.HasGrab True if the HasGrab flag is set. None.
- Property
  System.Boolean Convenience property to check Flags for WidgetFlags.CompositeChild True if the CompositeChild flag is set None
- Property
  System.Boolean Convenience property to check Flags for WidgetFlags.AppPaintable True if the AppPaintable flag is set None
- Property
  System.Boolean Convenience property to check Flags for WidetFlags.DoubleBuffered True if the DoubleBuffered flag is set. None
- Property
  System.Boolean Convenience property to check if the widget is Visible and Realized. True if the widget is able to be drawn on None
- Method
  System.Void `` Convenience method to set a flag. a to set None.
- Method
  System.Void `` Convenince method to clear a flag a to set None
- Method
  System.Void `` `` Virtual method to support scrollable widgets. a horizontal plane a vertical plane Override this method in a subclass to support scrolling of the widget within a viewport smaller than the widget's size.
- Property
  Gtk.Requisition Obtains the widget's requisition. a

  Obtains requisition, unless someone has forced a particular geometry, in which case it returns that geometry instead of the widget's requisition. This method differs from in that it retrieves the last size request value, while the method recomputes the size request and fills in the requisition, and then returns the recomputed value.

- Property
  System.Boolean To be added a To be added
- Event
  Gtk.AccelCanActivateHandler To be added To be added
- Method
  System.Boolean `` To be added a a To be added
- Method
  System.Void `` To be added a To be added
- Method
  System.Void `` `` `` `` To be added a a a a To be added
- Method
  System.Void `` To be added a To be added
- Method
  System.Void `` `` To be added a a To be added
- Method
  System.Void To be added To be added
- Method
  System.Void `` `` To be added a a To be added
- Method
  System.Void To be added To be added
- Method
  GLib.List To be added a To be added
- Method
  System.Boolean `` To be added a a To be added
- Method
  System.Void `` To be added a To be added
- Method
  System.Void `` `` Creates the GObject underlying a managed subclass an array of (GObject) property names the values for the properties identified by See for more details. This overridden method also sets up event handlers on the object to ensure that the wrapper object always stays alive when the widget is contained by another widget (even when it is contained by an unmanaged widget that doesn't know about its managed wrapper).